
import java.sql.*;


/**
 * Test all the SQLServer datatypes in Statement and PreparedStatement
 *
 */
public class t0017
{
   static public void main(String args[])
      throws SQLException, java.lang.ClassNotFoundException
   {
      System.out.println("Test all the SQLServer datatypes in Statement and PreparedStatement");
      System.out.println("!!!Note- This test is not fully implemented yet!!!");

      // open the database
      Class.forName("com.internetcds.jdbc.tds.Driver");

      boolean     passed   = true;
      int         count    = 0;
      Connection  cx       = Common.getConnection();
      Statement   stmt     = cx.createStatement();
      ResultSet   rs;

      try
      {
         stmt.executeUpdate("drop table t0017");
      }
      catch (SQLWarning e)
      {
         if (! (e.getMessage().startsWith("Cannot drop the table 't0017', because it does")))
         {
            throw e;
         }
      }

      String sql =
         "create table t0017 (                                  " +
         " mybinary                   binary(5) not null,       " +
         " myvarbinary                varbinary(4) not null,    " +
         " mychar                     char(10) not null,        " +
         " myvarchar                  varchar(8) not null,      " +
         " mydatetime                 datetime not null,        " +
         " mysmalldatetime            smalldatetime not null,   " +
         " mydecimal10_3              decimal(10,3) not null,   " +
         " mynumeric5_4               numeric (5,4) not null,   " +
         " myfloat6                   float(6) not null,        " +
         " myfloat14                  float(6) not null,        " +
         " myreal                     real not null,            " +
         " myint                      int not null,             " +
         " mysmallint                 smallint not null,        " +
         " mytinyint                  tinyint not null,         " +
         " mymoney                    money not null,           " +
         " mysmallmoney               smallmoney not null,      " +
         " mybit                      bit not null,             " +
         " mytimestamp                timestamp not null,       " +
         " mytext                     text not null,            " +
         " myimage                    image not null,           " +
         " mynullbinary               binary(3) null,          " +
         " mynullvarbinary            varbinary(6) null,       " +
         " mynullchar                 char(10) null,            " +
         " mynullvarchar              varchar(40) null,         " +
         " mynulldatetime             datetime null,            " +
         " mynullsmalldatetime        smalldatetime null,       " +
         " mynulldecimal10_3          decimal(10,3) null,       " +
         " mynullnumeric15_10         numeric(15,10) null,      " +
         " mynullfloat6               float(6) null,            " +
         " mynullfloat14              float(14) null,           " +
         " mynullreal                 real null,                " +
         " mynullint                  int null,                 " +
         " mynullsmallint             smallint null,            " +
         " mynulltinyint              tinyint null,             " +
         " mynullmoney                money null,               " +
         " mynullsmallmoney           smallmoney null,          " +
         " mynulltext                 text null,                " +
         " mynullimage                image null)               ";

      count = stmt.executeUpdate(sql);


      // Insert a row without nulls via a Statement
      sql =
         "insert into t0017               " +
         "  (mybinary,                    " +
         "   myvarbinary,                 " +
         "   mychar,                      " +
         "   myvarchar,                   " +
         "   mydatetime,                  " +
         "   mysmalldatetime,             " +
         "   mydecimal10_3,               " +
         "   mynumeric5_4,              " +
         "   myfloat6,                    " +
         "   myfloat14,                   " +
         "   myreal,                      " +
         "   myint,                       " +
         "   mysmallint,                  " +
         "   mytinyint,                   " +
         "   mymoney,                     " +
         "   mysmallmoney,                " +
         "   mybit,                       " +
         "   mytimestamp,                 " +
         "   mytext,                      " +
         "   myimage,                     " +
         "   mynullbinary,                " +
         "   mynullvarbinary,             " +
         "   mynullchar,                  " +
         "   mynullvarchar,               " +
         "   mynulldatetime,              " +
         "   mynullsmalldatetime,         " +
         "   mynulldecimal10_3,           " +
         "   mynullnumeric15_10,          " +
         "   mynullfloat6,                " +
         "   mynullfloat14,               " +
         "   mynullreal,                  " +
         "   mynullint,                   " +
         "   mynullsmallint,              " +
         "   mynulltinyint,               " +
         "   mynullmoney,                 " +
         "   mynullsmallmoney,            " +
         "   mynulltext,                  " +
         "   mynullimage)                 " +
         " values                         " +
         "   (0x1213141516,               " + //   mybinary,
         "    0x1718191A,                 " + //   myvarbinary
         "    '1234567890',               " + //   mychar
         "    '12345678',                 " + //   myvarchar
         "    '19991015 21:29:59.01',     " + //   mydatetime
         "    '19991015 20:45',           " + //   mysmalldatetime
         "    1234567.089,                " + //   mydecimal10_3
         "    1.2345,                     " + //   mynumeric5_4
         "    65.4321,                    " + //   myfloat6
         "    1.123456789,                " + //   myfloat14
         "    987654321.0,                " + //   myreal
         "    4097,                       " + //   myint
         "    4094,                       " + //   mysmallint
         "    200,                        " + //   mytinyint
         "    19.95,                      " + //   mymoney
         "    9.97,                       " + //   mysmallmoney
         "    1,                          " + //   mybit
         "    null,                       " + //   mytimestamp
         "    'abcdefg',                  " + //   mytext
         "    0x0AAABB,                   " + //   myimage
         "    0x123456,                   " + //   mynullbinary
         "    0xAB,                       " + //   mynullvarbinary
         "    'z',                        " + //   mynullchar
         "    'zyx',                      " + //   mynullvarchar
         "    '1976-07-04 12:00:00.04',   " + //   mynulldatetime
         "    '2000-02-29 13:46',         " + //   mynullsmalldatetime
         "     1.23,                      " + //   mynulldecimal10_3
         "     7.1234567891,              " + //   mynullnumeric15_10
         "     987654,                    " + //   mynullfloat6
         "     0,                         " + //   mynullfloat14
         "     -1.1,                      " + //   mynullreal
         "     -10,                       " + //   mynullint
         "     126,                       " + //   mynullsmallint
         "     7,                         " + //   mynulltinyint
         "     -19999.00,                 " + //   mynullmoney
         "     -9.97,                     " + //   mynullsmallmoney
         "     '1234',                    " + //   mynulltext
         "     0x1200340056)              " + //   mynullimage)
         "";

      count = stmt.executeUpdate(sql);

      sql = "select * from t0017";
      rs = stmt.executeQuery(sql);
      if (!rs.next())
      {
         passed = false;
      }
      else
      {
         System.out.println("mybinary is " + rs.getObject("mybinary"));
         System.out.println("myvarbinary is " + rs.getObject("myvarbinary"));
         System.out.println("mychar is " + rs.getObject("mychar"));
         System.out.println("myvarchar is " + rs.getObject("myvarchar"));
         System.out.println("mydatetime is " + rs.getObject("mydatetime"));
         System.out.println("mysmalldatetime is " + rs.getObject("mysmalldatetime"));
         System.out.println("mydecimal10_3 is " + rs.getObject("mydecimal10_3"));
         System.out.println("mynumeric5_4 is " + rs.getObject("mynumeric5_4"));
         System.out.println("myfloat6 is " + rs.getObject("myfloat6"));
         System.out.println("myfloat14 is " + rs.getObject("myfloat14"));
         System.out.println("myreal is " + rs.getObject("myreal"));
         System.out.println("myint is " + rs.getObject("myint"));
         System.out.println("mysmallint is " + rs.getObject("mysmallint"));
         System.out.println("mytinyint is " + rs.getObject("mytinyint"));
         System.out.println("mymoney is " + rs.getObject("mymoney"));
         System.out.println("mysmallmoney is " + rs.getObject("mysmallmoney"));
         System.out.println("mybit is " + rs.getObject("mybit"));
         System.out.println("mytimestamp is " + rs.getObject("mytimestamp"));
         System.out.println("mytext is " + rs.getObject("mytext"));
         System.out.println("myimage is " + rs.getObject("myimage"));
         System.out.println("mynullbinary is " + rs.getObject("mynullbinary"));
         System.out.println("mynullvarbinary is " + rs.getObject("mynullvarbinary"));
         System.out.println("mynullchar is " + rs.getObject("mynullchar"));
         System.out.println("mynullvarchar is " + rs.getObject("mynullvarchar"));
         System.out.println("mynulldatetime is " + rs.getObject("mynulldatetime"));
         System.out.println("mynullsmalldatetime is " + rs.getObject("mynullsmalldatetime"));
         System.out.println("mynulldecimal10_3 is " + rs.getObject("mynulldecimal10_3"));
         System.out.println("mynullnumeric15_10 is " + rs.getObject("mynullnumeric15_10"));
         System.out.println("mynullfloat6 is " + rs.getObject("mynullfloat6"));
         System.out.println("mynullfloat14 is " + rs.getObject("mynullfloat14"));
         System.out.println("mynullreal is " + rs.getObject("mynullreal"));
         System.out.println("mynullint is " + rs.getObject("mynullint"));
         System.out.println("mynullsmallint is " + rs.getObject("mynullsmallint"));
         System.out.println("mynulltinyint is " + rs.getObject("mynulltinyint"));
         System.out.println("mynullmoney is " + rs.getObject("mynullmoney"));
         System.out.println("mynullsmallmoney is " + rs.getObject("mynullsmallmoney"));
         System.out.println("mynulltext is " + rs.getObject("mynulltext"));
         System.out.println("mynullimage is " + rs.getObject("mynullimage"));
      }
   

      // Insert a row with nulls via a Statement


      // Insert a row without nulls via a PreparedStatement


      // Insert a row with nulls via a PreparedStatement


      // Now verify that the database has the same data as we put in.

      
     System.out.println("\n" + (passed ? "Passed" : "Failed") 
                         + " t0017.\n");
      System.exit(passed ? 0 : 1);
   }
}

