import java.net.URL;
import java.util.*;
import java.sql.*;
// import com.internetcds.jdbc.tds.*;
import java.lang.Thread;
import java.math.BigDecimal;


public class t0020
{
   public static void main(String args[])
      throws java.sql.SQLException, java.lang.ClassNotFoundException,
      java.lang.IllegalAccessException, java.lang.InstantiationException,
      java.lang.InterruptedException
   {
      System.out.println("Test a three nested PreparedStatements");

      Class.forName("com.internetcds.jdbc.tds.Driver");

      boolean    passed = true;        
      Statement  stmt   = null;
      BigDecimal tmp1   = null;
      BigDecimal tmp2   = null;
      int        count  = 0;
      int        i      = 0;


      createTables();
      
      Connection cx = Common.getConnection();

      Statement         stmtA = cx.createStatement();
      PreparedStatement stmtB = cx.prepareStatement(
         "select i2b, s2 from t0020b where i2a=?");
      PreparedStatement stmtC = cx.prepareStatement(
         "select s3 from t0020c where i3=?");

      ResultSet rs1 = stmtA.executeQuery("select i1 from t0020a");
      while(rs1.next())
      {
         int  i1 = rs1.getInt("i1");
//         System.out.println("Handling i1=" + i1);
         stmtB.setInt(1, rs1.getInt("i1"));
         ResultSet rs2 = stmtB.executeQuery();
         while(rs2.next())
         {
            stmtC.setInt(1, rs2.getInt(1));
            ResultSet rs3 = stmtC.executeQuery();
            if (rs3.next())
            {
               // nop
            }
         }
      }
      System.out.println("\n" + (passed ? "Passed" : "Failed") 
                         + " t0020.\n");
      System.exit(passed ? 0 : 1);

   }


   static private void createTables()
      throws SQLException, java.lang.ClassNotFoundException
   {
      Connection cx   = Common.getConnection();
      Statement  stmt = cx.createStatement();
      int        i;
      int        j;
      int        k;

      try
      {
         stmt.executeUpdate("drop table t0020a");
      }
      catch (SQLWarning e)
      {
         if (! (e.getMessage().startsWith("Cannot drop the table 't0020a', because it does")))
         {
            throw e;
         }
      }
      try
      {
         stmt.executeUpdate("drop table t0020b");
      }
      catch (SQLWarning e)
      {
         if (! (e.getMessage().startsWith("Cannot drop the table 't0020b', because it does")))
         {
            throw e;
         }
      }
      try
      {
         stmt.executeUpdate("drop table t0020c");
      }
      catch (SQLWarning e)
      {
         if (! (e.getMessage().startsWith("Cannot drop the table 't0020c', because it does")))
         {
            throw e;
         }
      }
      
      stmt.executeUpdate("create table t0020a (     " +
                         "  i1   int not null,     " +
                         "  s1   char(10) not null " + 
                         ")                        " + 
                         "");
      stmt.executeUpdate("create table t0020b (     " +
                         "  i2a   int not null,     " +
                         "  i2b   int not null,     " +
                         "  s2   char(10) not null " + 
                         ")                        " + 
                         "");
      stmt.executeUpdate("create table t0020c (     " +
                         "  i3   int not null,     " +
                         "  s3   char(10) not null " + 
                         ")                        " + 
                         "");
      
      j = 0;
      k = 0;
      int nextB = 1;
      int nextC = 1;
      for(i=1; i<500; i++)
      {
         if (i%50 == 0)
         {
            System.out.print(i + "..");
         }
         stmt.executeUpdate("insert into t0020a   " +
                            "  values(" + i + ",  " +
                            "         'row"+i+"') " +
                            "");
         for(j=nextB; (nextB%5)!=0; j++, nextB++)
         {
            stmt.executeUpdate("insert into t0020b       " +
                               " values(" + i + ",       " +
                               "        " + j + ",       " +
                               "        'row"+i+"."+j+"' " +
                               "        )                " +
                               "");
            for(k=nextC; nextC%3!=0; k++, nextC++)
            {
               stmt.executeUpdate("insert into t0020c             " +
                                  " values(" + j + ",             " +
                                  "        'row"+i+"."+j+"."+k+"' " +
                                  "        )                      " +
                                  "");
            }
         }
      }
      System.out.println("");
      cx.close();
   }
}

